/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Ausgabe der Werte einer Funktion y = f(x) im Intervall von a bis b 
 * mit einer bestimmten Schrittweite dx
 * Berechnung des Funktionswertes in einer Methode
 */
public class FunktionMethode {
    public static void main(String[] args) {

        double a  = -5.0;
        double b  = 5.0;
        double dx = 1.0;

        double x;           // Argument der Funktion
        double y;           // Funktionswert

        // Vorbereitung der Schleife 

        x = a;              // Beginn des Intervalls

        // *solange* x noch innerhalb des Intervalls liegt:

        while (x <= b) {

            y = f(x);                   // Berechnung des Funktionswertes

            System.out.println(y);  

            x = x + dx;                 // x wird um die Schrittweite erhöht
        }

    }

    /**
    * Berechnung des Werte der Funktion y(x) = x*x-0.5*x+2
    */ 
    private static double f(double wert) {
        double ergebnis;

        ergebnis = wert * wert - 0.5 * wert + 2.0;

        return ergebnis;
    }

}
