import java.util.Scanner;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Formatierung eines Textes durch Begrenzung der Zeilenlänge
 * (mit lokaler Variablen, return-Anweisung)
 */
public class FormatierungV2 {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int zeilenlaenge=0;     // vorgegebene Zeilenlänge

        String zeile;           // Zeile des neuformatierten Textes
        int position;           // Position des Zeilenendes 
        int zaehler;            // zählt die erzeugten Zeilen 

        System.out.println("Bitte geben Sie die Zeilenlänge ein");
  
        // wenn es eine ganze Zahl in der Eingabe gibt
        if (scanner.hasNextInt()) {

            String zeilenrest;                  // lokale Variable (if)
        
            // nächste ganze Zahl
            zeilenlaenge = scanner.nextInt();       
            
            System.out.println("Zeilenlänge: " + zeilenlaenge);
            
            // eventueller Rest bis zum Zeilenende
            zeilenrest = scanner.nextLine();
            if (zeilenrest.length() > 0)
                System.out.println("[" + zeilenrest + "]" + " war doch nicht nötig ;-)");
        }
        
        else {
            System.out.println(scanner.next() + " ist leider keine ganze Zahl :-!");

            /*****/
            return;     // Beendigung der main-Methode und damit des ganzen Programms
            /*****/
        }
    
        // weitere Verarbeitung mit eingegeber Zeilenlänge
        
        zaehler = 0;
    
        System.out.println("Bitte geben Sie einen Text ein");

        zeile    = "";
        position = 0;

        // wortweise Eingabe 

        while (scanner.hasNext()) {

            /*****/
            String wort = scanner.next();   // lokale Variable (in while)
            /*****/

            // eine Zeile wird aus den eingelesenen Worten aufgebaut 

            zeile = zeile + " " + wort;

            // Position des Zeilenendes wird aktualisiert

            position = position + 1 + wort.length();

            if (position >= zeilenlaenge) {

                // wenn vorgegebene Zeilenlänge erreicht:
            
                zaehler = zaehler + 1;          

                ausgabeZeile(zaehler, zeile);       // Ausgabe der Zeile

                zeile    = "";                      // neue Zeile, noch leer
                position = 0;
            }
        }
        
        // eventuell noch nicht ausgegebene letzte Zeile
    
        if (zeile.length() > 0 ) {
            zaehler = zaehler + 1;
            ausgabeZeile(zaehler, zeile);
        }

    }        

    /**
    * Ausgabe einer Zeile
    */ 
    private static void ausgabeZeile(int nummer, String zeile) {
        System.out.println("Zeile " + nummer + ":" + zeile);
    }

}
