/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Plot einer Funktion y = f(x) mittels '*'-Zeichen 
 * im Intervall von a bis b mit Schrittweite dx
 * (mit lokalen Variablen)
 */
public class FunktionPlotV2 {
    public static void main(String[] args) {

        double a  = -2.0;
        double b  = 3.0;
        double dx = 0.25;

        double x;

        x = a;
        // *solange* x innerhalb des Intervalls liegt:    
        while (x <= b) {

            /*****/
            double y = f(x);            // lokale Variable (while)
            /*****/

            /*****/
            double pos = 0.0;           // lokale Variable (while)
            /*****/

            // *solange* pos "links" des Funktionswertes liegt:
            while ( pos < y ) {

                System.out.print(' ');

                pos = pos + dx/2.0;     // nächster Positionsschritt
                }

            System.out.println('*');    // entspricht dem Funktionswert

            x = x + dx;                 // nächster x-Wert
        }

    }

    /**
    * Berechnung der Funktion -0.01*x^5 + 0.08*x^4 - 0.26*x^3 - 0.31*x^2 + 1.4*x + 2.36
    */ 
    static double f(double x) {
        return -0.01*x*x*x*x*x + 0.08*x*x*x*x - 0.26*x*x*x - 0.31*x*x + 1.4*x + 2.36;
    }

}
