/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Plot einer Funktion y = f(x) mittels '*'-Zeichen 
 * im Intervall von a bis b mit n Schritten, ... ,
 * mit Trennung des Berechnens und Zeichnens der Funktionswerte,
 * mit einem Array zum Speichern der Funktionswerte
 */
public class FunktionPlotV5 {
    public static void main(String[] args) {

        double a  = -2.0;
        double b  = -2.0;
        int    n  = 30;

        double dx = (b - a) / n ;

        /***********************************/        
        double [ ] wert = new double [ n+1 ];       // Array der Länge n+1 von double-Variablen
        /***********************************/       // zum Speichern der n+1 Funktionswerte       

        // Berechnen und Speichern der Funktionswerte
    
        for (int i = 0; i <= n; i++) {

            double x = a + i * dx;

            double y = f(x);

            // Speichern des i.ten Funktionswertes (Wert von y): 
            /***************/  
            wert [ i ]  = y ;                       // Zuweisung an die Variable 'wert[i]'
            /***************/  

            }

        // Zeichnen der Funktionswerte 

        for (int i = 0; i <= n; i++) {

                              /********/
            int pos = (int) ( wert [ i ] / dx );    // Verwendung des gespeicherten Wertes
                              /********/

            String s = positionszeichen(pos, 2, '*');

            System.out.println(s);

            }

    }

    /**
    * Erzeugung einer Zeichenkette, die aus n Leerzeichen, gefolgt von einem Zeichen ch, besteht
    */
    private static String positionszeichen(int n, int k, char c) {

        String s = ""; // mittels dieser lokalen Variablen wird das Ergebnis aufgebaut

        // n*k-maliges Anfügen eines Leerzeichens
        for(int i = 0; i < k*n; i++)
            s += ' ';

        // abschließendes Anfügen des Zeichens ch
        s += c;

        return s;   // Rückgabe der fertigen Zeichenkette
    }

    /**
    * Berechnung der Funktion -0.01*x^5 + 0.08*x^4 - 0.26*x^3 - 0.31*x^2 + 1.4*x + 2.36
    */ 
    private static double f(double x) {
        return -0.01*x*x*x*x*x + 0.08*x*x*x*x - 0.26*x*x*x - 0.31*x*x + 1.4*x + 2.36;
    }

}
