/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Berechnung der Tage eines Monats
 */
public class Monatstage {
    public static void main(String[] args) {

        int monat = 6;

        System.out.println("Monat " + monat + " hat " + tage(monat)   + " Tage");
        System.out.println("Monat " + monat + " hat " + tageV2(monat) + " Tage");
        System.out.println("Monat " + monat + " hat " + tageV3(monat) + " Tage");
    }

    /**
    * Berechnung der Anzahl der Tage eines Monats
    * mittels if-Anweisungen
    */
    private static int tage(int monat) {
        int t=0; 

        if ( monat == 1 )
            t = 31;
        else if ( monat == 2 )
            t = 28;
        else if ( monat == 3 )
            t = 31;
        else if ( monat == 4 )
            t = 30;
        else if ( monat == 5 )
            t = 31;
        else if ( monat == 6 )
            t = 30;
        else if ( monat == 7 )
            t = 31;
        else if ( monat == 8 )
            t = 31;
        else if ( monat == 9 )
            t = 30;
        else if ( monat == 10 )
            t = 31;
        else if ( monat == 11 )
            t = 30;
        else if ( monat == 12 )
            t = 31;

        return t;
    }

    /**
    * Berechnung der Anzahl der Tage eines Monats
    * mittels switch-Anweisung
    */
    private static int tageV2(int monat) {
        int t=0; 

        switch ( monat ) {

            case 2:             // Februar
                t = 28;
                break;
 
            case 4:             // April
            case 6:             // ...
            case 9: 
            case 11: 
                t = 30;
                break;

            case 1: 
            case 3: 
            case 5:
            case 7:  
            case 8: 
            case 10: 
            case 12: 
                t = 31;
                break;
        
        }

        return t;
    }

    /**
    * Berechnung der Anzahl der Tage eines Monats
    * mittels switch-Anweisung mit default-Zweig
    */
    private static int tageV3(int monat) {
        int t=0; 

        switch ( monat ) {

            case 2: 
                t = 28;         // Februar
                break;
 
            case 4:             // April
            case 6:             // ...
            case 9: 
            case 11: 
                t = 30;
                break;

            default:            // alle anderen Monate
                t = 31;
        
        }

        return t;
    }

}
