/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Zeichenersetzung, rekursiv
 * mit Ausgabe des Aufrufs
 */
public class ErsetzenRekursivV2 {
    public static void main(String[] args) {

        String string = "aaabbcccccddd";

        // aus dem String mit 'toCharArray' ein neues Zeichenarray erzeugen
        char[] zarray = string.toCharArray();

        System.out.println("7:"+zarray[7]);

        // Ersetzung durchführen
        ersetze ( zarray , 7, 'X' );
        System.out.println();        

        // aus dem Zeichenarray mit 'valueOf' einen neuen String erzeugen und ausgeben        
        System.out.println(String.valueOf(zarray)); // Ergebnis: aaabbXXXXXddd

    }

    /**
    * Ersetzung des Zeichen an der Position 'pos' durch 'zeichen', sowie
    * der Zeichen davor und danach - bis ein anderes Zeichen angetroffen wird
    */
    private static void ersetze ( char[] zeichenfolge, int pos, char zeichen ) {

        char z = zeichenfolge[pos]; // das Zeichen an der Position 'pos'

        System.out.println();
        System.out.println("ersetze( " + elements(zeichenfolge) + ", " 
                                            + pos + ", " + zeichen + " );");

        // das Zeichen an der Position 'pos' ersetzen
        zeichenfolge[pos] = zeichen;

        System.out.println("         "+ elements(zeichenfolge));

        System.out.println("         links  " + (pos-1) + ":" + zeichenfolge[pos-1]);
        // wenn es links davon noch ein Zeichen gibt und es mit z identisch ist:

        if (pos > 0 && zeichenfolge[pos-1] == z)
            ersetze ( zeichenfolge, pos-1, zeichen );

        System.out.println("         rechts " + (pos+1) + ":" + zeichenfolge[pos+1]);
        // wenn es rechts davon noch ein Zeichen gibt und es mit z identisch ist:

        if (pos < zeichenfolge.length-1 && zeichenfolge[pos+1] == z)
            ersetze ( zeichenfolge, pos+1, zeichen );
    }

    /**
    * Liefert alle Elemente eines Zeichenarrays mit Indizes
    */
    private static String elements( char[] ca ) {
        String r = "|";
        for (int i = 0; i < ca.length; i++)
            r = r + i + ":" + ca[i] + "|";
        return r;
    }

}
