import java.util.Scanner;
/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Formatierung eines Textes durch Begrenzung der Zeilenlänge
 * mit Ausgaben (mittels System.out.println) die die Ausführung
 * genau zeigen. Betrachten Sie die unterschiedliche Verarbeitung 
 * der Eingaben:
 *
hallo wie
geht es heute
 *
hallo wie geht
es heute
 *
hallo wie geht
es heute so?
 *
 */
public class FormatierungFixedV2 {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int zeilenlaenge;       // vorgegebene Zeilenlänge

        String wort;

        String zeile;           // Zeile des neuformatierten Textes
        int position;           // Position des Zeilenendes 
        int zaehler;            // zählt die erzeugten Zeilen 

        zeilenlaenge = 10;

        zaehler = 0;

        System.out.println("Bitte geben Sie einen Text ein");

        zeile    = "";
        position = 0;

        // wortweise Eingabe 

        int i = 0; // zählt Schleifendurchläufe

        while (scanner.hasNext()) {
            System.out.println( "> while-Schleife (" + (++i) + ")");

            wort = scanner.next();

            // eine Zeile wird aus den eingelesenen Worten aufgebaut 

            zeile = zeile + " " + wort;
            
            // was hat sich in der neuen Zeile bereits angesammelt? 
            System.out.println( "(\"" + zeile + "\")");

            // Position des Zeilenendes wird aktualisiert

            position = position + 1 + wort.length();

            if (position >= zeilenlaenge) {

                // wenn vorgegebene Zeilenlänge erreicht:
                
                zaehler = zaehler + 1;          

                ausgabeZeile(zaehler, zeile);       // Ausgabe der Zeile

                zeile    = "";                      // neue Zeile, noch leer
                position = 0;
            }
        }

        System.out.println( "> while-Schleife beendet" );

        
        // eventuell noch nicht ausgegebene letzte Zeile
        
        if (zeile.length() > 0 ) {
            zaehler = zaehler + 1;
            ausgabeZeile(zaehler, zeile);
        }

    }        

    /**
    * Ausgabe einer Zeile
    */ 
    private static void ausgabeZeile(int nummer, String zeile) {
        System.out.println("*** Zeile " + nummer + ":" + zeile + " ***");
    }

}
