/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Verwendung von Strings und Character-Arrays
 */
public class StringMan2 {
    public static void main(String[] args) {

    String s = "Programmierpraxis";
    char[] a;

    System.out.println( "/" + s + "/");

    System.out.println( istenthalten (s, 'a') );

    System.out.println( istenthalten (s, 'u') );


    a = s.toCharArray();
    verschiebelinks(a);
    System.out.println( "/" + String.valueOf(a) + "/");

    a = s.toCharArray();
    verschieberechts(a);
    System.out.println( "/" + String.valueOf(a) + "/");

    }

    /**
    * Prüft, ob ein Zeichen in einem String vorkommt
    */
    private static boolean istenthalten(String s, char z) {
        boolean gefunden = false;                   

        // Schleife über alle Zeichen
        for (int i = 0; i < s.length() && !gefunden ; i++) {    // bis das Zeichen gefunden wurde
            System.out.println("i = " + i );
            if ( s.charAt(i) == z) 
                gefunden = true;                                // das Zeichen wurde gefunden
        }

        return gefunden;
    }

    /**
    * Verschiebt um eine Stelle nach links und füllt mit ' ' auf
    */
    private static void verschiebelinks(char[] a) {

        for (int i = 0; i < a.length-1; i++) {

            a[ i ] = a[ i+1 ];                                  // ersetze Zeichen durch jenes rechts davon
        }

        a[ a.length-1 ] = ' ';                                  // setze letztes Zeichen auf Leerzeichen
    }

    /**
    * Verschiebt um eine Stelle nach rechts und füllt mit ' ' auf
    */
    private static void verschieberechts(char[] a) {

        for (int i = a.length-1; i > 0; i--) {                  // beginne beim letzten Zeichen!

            a[ i ] = a[ i-1 ];                                  // ersetze Zeichen durch jenes links davon
        }

        a[ 0 ] = ' ';                                               // setze erstes Zeichen auf Leerzeichen
    }

}
