/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Ein Stack von ganzzahligen Werten
 */
class Stack {

        private int[] elements;     // die Werte

        private int count;          // aktuelle Größe (default: 0)

    /**
    * Konstruktor liefert einen leeren Stack einer bestimmten Kapazität
    */
    public Stack(int capacity) { 
        elements = new int[capacity];
        }

    /**
    * Test auf "empty"
    */
    public boolean isempty() {
        return ( count == 0 );     // aktuelle Größe ist 0
        }

    /**
    * liefert aktuelle Größe des Stacks
    */
    public int size() {
        return count;
        }

    /**
    * Operation "push" 
    */
    public boolean offerfirst(int number) {

        if ( count == elements.length )             // Kapazität erreicht
            return false;
        else {
            elements[ count++ ] = number;          // number hinzufügen
            return true;
        }
    }
        
    /**
    * Operation "pop"
    */
    public int pollfirst() {

        if ( count == 0 )
            return -999999;
        else 
            return elements[ --count ];
    }

}
