import java.util.Scanner;
/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * RandomSurfer ohne Leerzeilen und Kommentare
 */
public class RandomSurferCode {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        Page[] pages = new Page[scanner.nextInt()];
        for (int i=0; i<pages.length; i++) {
            pages[i] = new Page(scanner.next(), scanner.nextInt());
        }
        for (int i=0; i<pages.length; i++) {
            for (int j=0; j<pages[i].getDegree(); j++) {
                int k = scanner.nextInt();      
                pages[i].setLink( j, pages[k-1] ); 
            }
        }
        for (int i=0; i<pages.length; i++) {
            for (int j=0; j<pages[i].getDegree(); j++) {
                Page p = pages[i].getLink(j);
            }
        }
        int totalVisits = scanner.nextInt();        
        Page currentPage = pages[0];                
        int visitCount = 0;                         
        while ( visitCount++ < totalVisits ) {
            if (Math.random() < 0.90) {
                int k = (int)( Math.random() * currentPage.getDegree());
                currentPage = currentPage.getLink(k);
            }
            else {
                int k = (int)( Math.random() * pages.length );
                currentPage = pages[k];
            }
            currentPage.incrementCount();           
        }
        for (int i=0; i<pages.length; i++) 
            System.out.println( "page " + pages[i].getURL() + ": " + pages[i].getCount()
                + " visits (" + ( pages[i].getCount() / (totalVisits/100.0) ) + " %)");
    }
}
