/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Volladdierer-Klasse
 */
public class FullAdderComponent {

    // ein Volladierer besteht aus zwei Halbaddiern und einem OR-Gatter
    private HalfAdderComponent ha1;
    private HalfAdderComponent ha2;
    private Gate or;

    public FullAdderComponent(Gate x, Gate y, Gate cIn) {

        // Aufbau des Volladierers
        ha1 = new HalfAdderComponent( x, y);
        ha2 = new HalfAdderComponent( ha1.getSum(), cIn);
        or  = new Gate( ha1.getCarry(), "OR", ha2.getCarry());
    }

    // Volladierer schaltet (Reihenfolge!)
    public void operate() {
        ha1.operate();
        ha2.operate();
        or.operate();
    }

    // sum-Ausgang
    public Gate getSum() {
        return ha2.getSum();
    }

    // carry-Ausgang
    public Gate getCarryOut() {
        return or;
    }

}
