/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Halbaddierer
 */
public class HalfAdder {
    public static void main(String[] args) {

        // Eingänge des Halbadierers: (Pseudo-) Gatter ohne Operation
        Gate x  = new Gate();
        Gate y  = new Gate();       
    
        // Aufbau des Halbadierers aus den Gattern
        Gate not1 = new Gate("NOT", x);             // NOT x
        Gate not2 = new Gate("NOT", y);             // NOT y
        Gate and1 = new Gate(not1, "AND", y);       // (NOT x) AND y
        Gate and2 = new Gate(x, "AND", not2);       // x and (NOT y)
        Gate or   = new Gate(and1, "OR", and2);     // s = ((NOT x) AND y) OR (x and (NOT y))
        Gate and3 = new Gate(x, "AND", y);          // c = x AND y
        
        // Belegung der Eingänge
        x.setValue(true);
        y.setValue(false);
    
        // Halbadierer schaltet: Durchführung der Operationen aller Gatter (Reihenfolge!)
        not1.operate();
        not2.operate();
        and1.operate();
        and2.operate();
        or.operate();
        and3.operate();
    
        // Ergebnis
        boolean s = or.getValue();                  // sum 
        boolean c = and3.getValue();                // carry 
    
        System.out.println("sum   = " + s);
        System.out.println("carry = " + c);

    }

}
