/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die einen *färbigen* Kreis mit Mittelpunkt
 * und Radius repräsentiert (eine Farbe für die 
 * Kreislinie und eine weitere für die Kreisfläche).
 * Unterklasse der Klasse Circle.
 */
public class ColorCircle extends Circle {

    String lineColor, fillColor;

    // Konstruktor 
    public ColorCircle(double x, double y, double r, 
                        String lineColor, String fillColor) {
        super(x, y, r); // Aufruf des Konstruktors der Oberklasse
        this.lineColor = lineColor; 
        this.fillColor = fillColor;
    }

    // Kopierkonstruktor
    public ColorCircle(Circle c, String lineColor, String fillColor) {
        super(c);       // Aufruf des Konstruktors der Oberklasse 
        this.lineColor = lineColor; 
        this.fillColor = fillColor;
    }

    public void draw(DrawWindow dw) { 
        // Aufruf einer Methode des übergebenen Zeichenfenster-Objekts dw
        dw.drawCircle(x, y, r, fillColor, lineColor); 
    }

}
