/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die einen Kreis mit Zeichenattributen repräsentiert.
 */
public class DrawableCircle extends Circle implements Drawable {

    DrawAttributes da;

    public DrawableCircle(double r) { 
        super(r); 
        da = new DrawAttributes();
    }

    public void setColors(String lc, String fc) {
        da.setColors(lc, fc);
    }

    public void setPosition(double x, double y) { 
        da.setPosition(x, y);
    }

    public void draw(DrawWindow dw) { 
        dw.drawCircle(da.getX(), da.getY(), r, da.getLineColor(), da.getFillColor());
    }

}
