package sensor.sensors;

/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 * Diese Klasse definiert einen Lichtsensor. Hier wird das Auslesen des Wertes
 * implementiert (simuliert durch Zufallszahlen).
 */
import sensor.AbstractSensor;
public class LightSensor extends AbstractSensor {

    // Konstruktor: ruft Konstruktor von AbstractSensor auf 
    public LightSensor(String name) { 
        super(name);
    }

    // Auslesen des Lichtwertes
    protected void readValue() {
        setValue(Math.random()*4000.0+2000.0);
    }

}
