package sensor;

import java.util.Date;
/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 * Dieses Interface definiert die Funktionalität eines Sensors.
 */
public interface Sensor {
    public String getName();    // liefert den Namen des Sensors
    public void read();         // das Auslesen des Sensors, zu einem bestimmten Zeitpunkt
    public Date getDate();      // liefert den Zeitpunkt des letztmaligen Auslesens mittels read()
    public double getValue();   // liefert den zuletzt mittels read() ausgelesenen Wert
}
