/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 * Gatter
 * der Wert am Ausgang wird in value gespeichert
 */
public abstract class Gate implements Component {

    private Signal value;     // Ausgang des Gatters
    static int n;             // Anzahl der Gate-Objekte  

    public Gate() {
        value = new Signal();
        n++;                  // Zählen der Instanzen von Gate
    }

    void setValue(boolean v) {
        value.set(v);
    }

    public Signal out() {
        return value;
    }

}
