/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Digitale Schaltungen
 */
public class Main {
    public static void main(String[] args) {

    // Eingänge des Volladierers
    Signal x    = new Signal();
    Signal y    = new Signal();     
    Signal cIn  = new Signal();     

    // Erzeugung des Volladdierers
    FullAdder fa = new FullAdder(x, y, cIn);

    // Belegung der Eingänge
    x.set(true);
    y.set(false);
    cIn.set(false);

    // Volladierer schaltet
    fa.operate();

    // Ergebnis
    System.out.println("sum      = " + fa.getSum().get());
    System.out.println("carryOut = " + fa.getCarryOut().get());

    // Statistik
    System.out.println("compound components: " + CompoundComponent.n);
    System.out.println("gates: " + Gate.n);
    System.out.println("and: " + And.n);
    System.out.println("or: " + Or.n);
    System.out.println("not: " + Not.n);

    }

}
