/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 */
class Article extends Thing implements Printable {

    private double price;   // auf price wird in Unterklassen nicht direkt zugegriffen

    Article(String name) {
        super(name);        // Konstruktor von Thing
        price = 10.0;       // Standardpreis
    }

    Article(String name, double price) {    // price in Euro angegeben
        this(name);
        setPrice(price);
    }

    protected void setPrice(double price) { // wird in Unterklassen aufgerufen
        this.price = price;                 // price in Euro wird gespeichert
    }

    protected double getPrice() {           // wird in Unterklassen aufgerufen
        return price;
    }

    public String format() {                // Preis 8-stellig, 2 Nachkommastellen
        return name + " EUR " + String.format( "%8.2f", price );
    }

}
