/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Numerische Berechnung des Integrals einer Funktion y(x) = f(x)
 * im Integrationsbereich von a bis b mit Schrittweite dx (Rechteckregel) 
 */
public class IntegrationMethode {
    public static void main(String[] args) {

        double a  = -5.0;
        double b  = 5.0;
        double dx = 0.25;

        double x;
        double y;
         
        double summe;
        int zaehler;        // zählt die Schritte

        // Vorbereitung der Schleife 

        summe = 0.0;
        zaehler = 0;
        x = a + dx * 0.5;               // erster x-Wert    

        // *solange* x innerhalb des Intervalls liegt:      
        
        while ( x < b ) {

            summe = summe + f(x);       // summe wird um den Funktionswert erhöht

            x = x + dx;                 // nächster x-Wert
            zaehler = zaehler + 1;  
        }

        System.out.println(dx * summe); // Wert des Integrals     
        System.out.println(zaehler);        

    }
    
    /**
    * Berechnung des Werte der Funktion y(x) = x*x-0.5*x+2
    */ 
    private static double f(double wert) {
        double ergebnis;

        ergebnis = wert * wert - 0.5 * wert + 2.0;

        return ergebnis;
    }
        
}
