/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Plot einer Funktion y = f(x) mittels '*'-Zeichen 
 * im Intervall von a bis b mit n Schritten, ... ,
 * mit Trennung der Erstellung und Ausgabe der Zeilen,
 * mit einem Array zum Speichern der Zeilen
 */
public class FunktionPlotV6 {
    public static void main(String[] args) {

        double a  = -2.0;
        double b  = -2.0;
        int    n  = 30;

        double dx = (b - a) / n ;
        
        double [ ] wert = new double [ n+1 ];       

        /***********************************/  
        String [ ] plot = new String [ n+1 ];       // Array der Länge n+1 von String-Variablen
        /***********************************/       // zum Speichern der auszugebenden Zeilen

        // Berechnen und Speichern der Funktionswerte
    
        for (int i = 0; i<=n; i++) {

            double x = a + i * dx;
            double y = f(x);
            wert[i]  = y;                       

            }

        // Erstellen der "Zeichnung" (einzelne Zeilen)

        for (int i = 0; i<=n; i++) {

            int pos = (int) ( wert[i] / dx );
            String s = positionszeichen(pos, 2, '*');

            // Speichern der i.ten Zeile (Wert von s)
            /*************/ 
            plot [ i ] = s;                     // Zuweisung an die Variable 'plot[i]'
            /*************/ 

            }

        // Ausgabe des Plots

        for (int i = 0; i<=n; i++) {

                                /********/
            System.out.println( plot [ i ] );   // Ausgabe der gespeicherten Zeile
                                /********/

            }

    }

    /**
    * Erzeugung einer Zeichenkette, die aus n Leerzeichen, gefolgt von einem Zeichen ch, besteht
    */
    private static String positionszeichen(int n, int k, char c) {

        String s = ""; // mittels dieser lokalen Variablen wird das Ergebnis aufgebaut

        // n*k-maliges Anfügen eines Leerzeichens
        for(int i = 0; i < k*n; i++)
            s += ' ';

        // abschließendes Anfügen des Zeichens ch
        s += c;

        return s;   // Rückgabe der fertigen Zeichenkette
    }

    /**
    * Berechnung der Funktion -0.01*x^5 + 0.08*x^4 - 0.26*x^3 - 0.31*x^2 + 1.4*x + 2.36
    */ 
    private static double f(double x) {
        return -0.01*x*x*x*x*x + 0.08*x*x*x*x - 0.26*x*x*x - 0.31*x*x + 1.4*x + 2.36;
    }

}
