/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Zeichenersetzung, rekursiv
 */
public class ErsetzenRekursiv {
    public static void main(String[] args) {

        String string = "aaabbcccccddd";

        // aus dem String mit 'toCharArray' ein neues Zeichenarray erzeugen
        char[] zarray = string.toCharArray();

        // Ersetzung durchführen
        ersetze ( zarray , 7, 'X' );        

        // aus dem Zeichenarray mit 'valueOf' einen neuen String erzeugen und ausgeben        
        System.out.println(String.valueOf(zarray)); // Ergebnis: aaabbXXXXXddd

    }

    /**
    * Ersetzung des Zeichen an der Position 'pos' durch 'zeichen', sowie
    * der Zeichen davor und danach - bis ein anderes Zeichen angetroffen wird
    */
    private static void ersetze ( char[] zeichenfolge, int pos, char zeichen ) {

        char z = zeichenfolge[pos]; // das Zeichen an der Position 'pos'

        // das Zeichen an der Position 'pos' ersetzen
        zeichenfolge[pos] = zeichen;

        // wenn es links davon noch ein Zeichen gibt und es mit z identisch ist:
        if (pos > 0 && zeichenfolge[pos-1] == z) 
            // dieses ebenfalls ersetzen: rekursiver Aufruf
            ersetze ( zeichenfolge, pos-1, zeichen );

        // wenn es rechts davon ein Zeichen gibt und es mit z identisch ist:
        if (pos < zeichenfolge.length-1 && zeichenfolge[pos+1] == z) 
            // dieses ebenfalls ersetzen: rekursiver Aufruf
            ersetze ( zeichenfolge, pos+1, zeichen );
    }

}
