import java.util.Scanner;
/** 
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Eingabe mittels Scanner, zeilenweise
 * Speichern der Eingabe in String-Array.
 * Die Anzahl der Zeilen wird zuvor eingegeben.
 */
public class EingabeZeileArrayV2 {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int zaehler;

        /*******************************/
        int anzahl;                                 // einzugebende Zeilenanzahl    
        /*******************************/

        // wenn es eine ganze Zahl in der Eingabe gibt

        if (scanner.hasNextInt()) {
            String rest;                            
            anzahl = scanner.nextInt();             // nächste ganze Zahl
            rest = scanner.nextLine();              // eventueller Rest bis zum Zeilenende
        }

        else {
            System.out.println(scanner.next() + " ist leider keine ganze Zahl :-!");
            return;
        }

        zaehler = 0;
        
        /***********************************/
        String[] zeilen = new String[anzahl];       // Arraylaenge ist Zeilenanzahl
        /***********************************/

        // solange es eine Zeile in der Eingabe gibt:

        while (scanner.hasNextLine()) {

            // Speichern der eingelesenen Zeilen
            zeilen[zaehler] = scanner.nextLine();

            zaehler = zaehler + 1; 

            // nach der letzten Zeile: Abbruch der Schleife
            if ( zaehler == anzahl )
                break;
            
        }

        // Ausgabe der gespeicherten Zeilen
         
        for (int i=0; i < zaehler; i++) 
            System.out.println("Zeile " + i + ": [" + zeilen[i] + "]");
            
    }

}
