/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Methoden für Strings
 */
public class StringMan {
    public static void main(String[] args) {

    String s = "Programmierpraxis";

    System.out.println("/" + s + "/");

    System.out.println( s.length() );               // Länge des Strings

    System.out.println( s.charAt( 3 ) );            // das 4. Zeichen

    System.out.println( s.substring( 3 ) );         // Teilstring ab inkl. 4. Zeichen

    System.out.println( s.substring( 3, 8 ) );      // Teilstring von inkl. 4.-7. Zeichen

    System.out.println( s.indexOf( 'a' ) );         // Position des ersten Vorkommnisses von 'a'

    System.out.println( s.indexOf( 'a', 6 ) );      // -"-, Suche beginnt beim 7. Zeichen

    char[] carr = s.toCharArray();                  // Deklaration und Erzeugung eines Zeichenarrays
                                                    // das die Zeichen des Strings enthält
    System.out.println( carr.length );              // Länge des Arrays

    System.out.println( carr[ 3 ] );                // das Zeichen an der Stelle 3 (Index beginnt mit 0)

    System.out.println( String.valueOf( carr ) );   // String, der die Elemente des Zeichenarrays enthält

    System.out.println( elements( carr ) );         // -"-, sowie die Indizes

    }

    /**
    * Liefert alle Elemente eines Zeichenarrays mit Indizes
    */
    private static String elements( char[] ca ) {
        String r = "|";
        for (int i = 0; i < ca.length; i++)
            r = r + i + ":" + ca[i] + "|";
        return r;   
    }
}
