/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Eine Webseite mit Links auf andere Seiten
 */
public class Page {

    private String url;     // URL

    private Page[] links;       // Links auf andere Seiten

    int count;                  // zählt Besuche dieser Seite
                                // default: 0

    /**
    * Konstruktor setzt URL und erzeugt das Link-Array
    * degree ... Anzahl der Links
    * Es kann auch mehr als einen Link auf dieselbe Seite geben.
    */
    public Page(String url, int degree) {
        this.url  = url;
        this.links = new Page[degree];
    }

    /**
    * liefert den URL der Seite
    */
    public String getURL() {
        return url;
    }

    /**
    * liefert die Anzahl der Links
    */
    public int getDegree() {
        return links.length;
    }
        
    /**
    * trägt den i.ten Link ein
    */
    public void setLink(int i, Page p) {
        links[i] = p;
    }

    /**
    * liefert den i.ten Link
    */
    public Page getLink(int i) {
        return links[i];
    }

    /**
    * erhöht den Zähler
    */
    public void incrementCount() {
        count++;
    }

    /**
    * liefert aktuellen Wert des Zählers
    */
    public int getCount() {
        return count;
    }
    
}
