/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Gatter-Klasse
 * Der Wert am Ausgang wird in value gespeichert
 */
public class Gate {

    private boolean value;          // Wert am Ausgang
    private String operation;       // Gatter-Operation
    private Gate input1;            // Eingang 1
    private Gate input2;            // Eingang 2 (falls vorhanden)

    // Gatter mit zwei Eingängen
    public Gate(Gate input1, String operation, Gate input2) {
        this.input1 = input1;
        this.input2 = input2;
        this.operation = operation;
    }

    // Gatter mit einem Eingang
    public Gate(String operation, Gate input) {
        this.input1 = input;
        this.operation = operation;
    }

    public Gate() {
        this.operation = "";        // keine Operation definiert
    }

    public boolean getValue() {
        return value;
    }

    public void setValue(boolean value) {
        this.value = value;
    }

    // Durchführung der Gatter-Operation
    public void operate() {
        if (! operation.equals("")) {

            if (operation.equals("AND")) {
                value = input1.getValue() && input2.getValue(); // AND
            }
            else if (operation.equals("OR")) {
                value = input1.getValue() || input2.getValue(); // OR
            }
            else if (operation.equals("NOT")) {                 // NOT
                value = ! input1.getValue();
            }
        }
    }

}
