/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die einen Kreis mit Mittelpunkt, Radius
 * und einer Umrandung repräsentiert.
 * Die Umrandung hat eine bestimmte Breite.
 * Keine Vererbung - Referenz auf Circle-Objekt
 */
public class ColorCircleV0 {
    
    public Circle c;

    String lineColor, fillColor;

    // Konstruktor 
    public ColorCircleV0(double x, double y, double r, 
                        String lineColor, String fillColor) {
        c = new Circle(x, y, r); 
        this.lineColor = lineColor; 
        this.fillColor = fillColor;
    }

    public double area() {
        return c.area(); 
    }

    public double circumference() {
        return c.circumference();
    }

    public void draw(DrawWindow dw) { 
        // Aufruf einer Methode des übergebenen Zeichenfenster-Objekts dw
        dw.drawCircle(c.x, c.y, c.r, fillColor, lineColor); 
    }

}
