/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Dieses Interface beinhaltet Methoden, die zum Zeichnen
 * einer Figur benötigt werden. Ein Objekt einer Klasse,
 * die dieses Interface implementiert, ist "draw-able".
 */
public interface Drawable {

    // Setzen der Zeichenposition
    void setPosition(double x,  double y);

    // Setzen der Zeichenfarben
    void setColors(String lineColor, String fillColor);
      
    // Drawable-Objekte werden gezeichnet
    public void draw(DrawWindow dw);

}
