/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Klasse, die ein Rechteck mit Zeichenattributen repräsentiert.
 */
public class DrawableRectangle extends Rectangle implements Drawable {

    DrawAttributes da;

    public DrawableRectangle(double w, double h) { 
        super(w,h); 
        da = new DrawAttributes();
    }

    public void setColors(String lc, String fc) {
        da.setColors(lc, fc);
    }

    public void setPosition(double x, double y) { 
        da.setPosition(x, y);
    }

    public void draw(DrawWindow dw) { 
        dw.drawRectangle(da.getX(), da.getY(), w, h, da.getLineColor(), da.getFillColor());
    }

}
