/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 */
import sensorpoint.SensorPoint;
import sensor.sensors.*; // für die einzelnen Sensoren
class Main {
    public static void main(String[] args) {

        // erzeuge einen Sensorpunkt an dieser Position
        SensorPoint sp = new SensorPoint(1.0, 2.0, 3.0);    

        // erzeuge Sensoren und füge sie hinzu
        sp.addSensor(new TemperatureSensor("Temp"));
        sp.addSensor(new LightSensor("Light1"));
        sp.addSensor(new LightSensor("Light2"));
        sp.addSensor(new HumiditySensor("Hum"));

        // Liste der Sensoren ausgeben
        sp.listSensorsV2();

        // Sensoren auslesen
        sp.readSensor("Temp");
        sp.readSensor("Light1");
        sp.readSensor("Hum");

        // Sensorpunkt ausgeben
        sp.printV2();
    }

}
