package sensor.sensors;

/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 * Diese Klasse definiert einen Luftfeuchtigkeitssensor. Hier wird das Auslesen des Wertes
 * implementiert (simuliert durch Zufallszahlen).
 */
import sensor.AbstractSensor;
public class HumiditySensor extends AbstractSensor {

    // Konstruktor: ruft Konstruktor von AbstractSensor auf     
    public HumiditySensor(String name) { 
        super(name);
    }

    // Auslesen des Luftfeuchtigkeitswertes     
    protected void readValue() {
        setValue(Math.random()*100.0);
    }

}
