package sensor.sensors;

/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 * Diese Klasse definiert einen Temperatursensor. Hier wird das Auslesen des Wertes
 * implementiert (simuliert durch Zufallszahlen).
 */
import sensor.AbstractSensor;
public class TemperatureSensor extends AbstractSensor {

    // Konstruktor: ruft Konstruktor von AbstractSensor auf     
    public TemperatureSensor(String name) { 
        super(name);
    }

    // Auslesen des Temperaturwertes    
    protected void readValue() {
        setValue(Math.random()*100.0-50.0);
    }

}
