package point;

/**
 * 183.592 Programmierpraxis TU Wien WS2014/15 H.Moritsch
 * Punkt mit Sensoren
 * Diese Klasse definiert einen Punkt auf der Erdobefläche. Der Punkt ist
 * durch seine Position, d.h. Länge, Breite, Höhe, definiert. Diese Werte
 * sind daher unveränderlich (final).
 */
public class Point{
    private final double l, b, h;   // Länge, Breite, Höhe: unveränderlich

    // Konstruktor  
    public Point(double l, double b, double h) {
        this.l = l;
        this.b = b;
        this.h = h;
    }
    
    // Formatierung als String
    public String toString() {
        return "("+l+", "+b+", "+h+")";
    }

}
